#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri Jul 16 21:12:37 2021

@author: moreaul
"""

import numpy as np
import os , sys
import matplotlib.pyplot as plt
import mcmc_iqk
#from scipy import fft as fft
#from scipy import ifft as ifft
#from geopy.distance import distance
#import math
#from random import random
#import matplotlib.pyplot as pyplot
#import time
import pickle
import shutil

#cluster = int(sys.argv[1])
#iqk = int(sys.argv[2])
cluster = 4
iqk = 975
sta_cluster = 125505
thick_var = 0 # set to 1 for sampling from differrent thicknesses for each statio, set to 0 for same thickness for each station  


stations = np.zeros((5,3)) 
stations[0,0] = 125505
stations[0,1] = 77.882769440000004
stations[0,2] = 16.772766669999999
stations[1,0] = 501101
stations[1,1] = 77.883772219999997
stations[1,2] = 16.773727780000002
stations[2,0] = 201104
stations[2,1] = 77.882833329999997
stations[2,2] = 16.768333330000001
stations[3,0] = 301103
stations[3,1] = 77.881669439999996
stations[3,2] = 16.773522220000000
stations[4,0] = 401103
stations[4,1] = 77.882663890000003
stations[4,2] = 16.778752780000001
Nsta = stations.shape[0]




path2icqks = '/Users/moreaul/Documents/Travail/Projets_Recherche/Icewaveguide/data/IWG/data_by_sta_fe_250Hz/output_scatnet_'+str(sta_cluster)+'/iqk_Agathe/'
# define method for time-frequency analysis. Either 'cwt' for continuous wavelet transform or stft for short-time Fourier transform
method = 'cwt'
#path2save = path2icqks + 'output_'+method + '_cluster'+  f'{cluster:02d}'+'_' +f'{iqk:05d}'+ '/'
path2save = '/Users/moreaul/Desktop/' + 'output_'+method + '_cluster'+  f'{cluster:02d}'+'_' +f'{iqk:05d}'+ '/'



fmin = 1
fmax = 70
fe = 250

# read the data, extract spectrum and center frequency
data, data_spect, fc,iqk_time = mcmc_iqk.read_data.read_data(path2icqks,stations,sta_cluster,cluster,iqk,fmin,fmax,fe,plot=0)
Nt = len(data[0]); 
t = np.arange(0,Nt/fe,1/fe) # /!\ must have an odd number of elements. This needs to be fixed in fwd_model.py -> Not trivial

    
if len(t) > Nt:
    t = t[0:-1]
    

# perform time-frequency analysis of the data with method defined above
data_scalogram = mcmc_iqk.data_cwt.data_cwt(data,fe,method,plot=0)






# generating gaussian tonuburst with amplitude spectra weighted by spectra of data
t0 = 0.5
SNR = np.inf
pulse = []
#fig1, axs1 = plt.subplots(1,1, figsize=(15, 5), facecolor='w', edgecolor='k')
for ista in range(len(stations)): 
    ncycle = 1.5/fc[ista]
    pulse.append(mcmc_iqk.gaussian_toneburst.gaussian_toneburst(fc[ista],t,t0,ncycle,0,0,SNR) )
    pulse_spect = np.fft.fft(pulse[ista])      
    idx = np.where(pulse_spect == 0)[0]
    if len(idx) != 0:
        for i_idx in idx:
            pulse_spect[i_idx] = pulse_spect[i_idx-1] 
    pulse_spect = pulse_spect/abs(pulse_spect)*abs(data_spect[ista])
    pulse[ista] = np.real(np.fft.ifft(pulse_spect))   
    #plt.plot(pulse[ista]/np.amax(pulse[ista])+ista)
    #plt.xlabel('time in icequake (s)')
    #plt.ylabel('normalize amplitude')
    #plt.title('synthetics with amplitude spectrum same as in data')
    
    
rho_ice = 910
E = 3.8e9
nu = 0.321
c_w = 1410;
rho_w = 1010;



# simulated annealing search space

lon_max = 16.8
lon_min = 16.74 
lat_max = 77.8875
lat_min = 77.875
max_thickness = 1
min_thickness = 0.2





if os.path.exists(path2icqks+'wavenum_cph_cluster'+  f'{cluster:02d}'+ '/'+'wavenum_and_cph_iqk'+str(iqk)+'.pkl'):
    with open(path2icqks+'wavenum_cph_cluster'+  f'{cluster:02d}'+ '/'+'wavenum_and_cph_iqk'+str(iqk)+'.pkl','rb') as f:  # Python 3: open(..., 'rb')
        k_QS, cph, hhh = pickle.load(f)
else:   
    dh = 1e-2; hhh = np.arange(min_thickness,max_thickness+dh,dh)
    cph = np.zeros((len(hhh),int((Nt-1)/2+1)))
    k_QS = np.zeros((len(hhh),int((Nt-1)/2+1)))
    for ih in range(len(hhh)):
        freq,k_QS[ih,:],_,_,cph[ih,:] = mcmc_iqk.fwd_model.wavenumbers_stein( rho_ice, hhh[ih], E, nu, fe,t,c_w,rho_w)

    with open(path2icqks+'wavenum_cph_cluster'+  f'{cluster:02d}'+ '/'+'wavenum_and_cph_iqk'+str(iqk)+'.pkl', 'wb') as f:  # Python 3: open(..., 'wb')
        pickle.dump([k_QS, cph, hhh], f)
    
    

#for ih in range(len(hhh)):   
#    plt.plot(cph[ih])
#fig1, ax1 = plt.subplots(figsize=(13, 5),nrows=1, ncols=3)
#plt.subplot(131)
#plt.plot(freq,k_QS) 
#plt.plot(freq,k_QS0) 
#plt.plot(freq,k_SH0)


# simulated annealing schedule
isave = 200
N_SA = 20000
N_MCMC = 100000
T0 = 0.1; Tmin = 0.0001
T0param = 0.4; Tminparam = 0.002






name2saveMCMC = 'inv_family_' + f'{cluster:02d}' +'_MCMC.hdf5' 
name2saveSA = 'inv_family_' + f'{cluster:02d}' +'_SA.hdf5' 

if os.path.exists(path2save+name2saveMCMC):
    import h5py 
    with h5py.File(path2save+name2saveMCMC , "r") as f:    
    #with h5py.File('/Users/moreaul/Documents/Travail/Projets_Recherche/Icewaveguide/data/DAMOCLES/output_scatnet_DAMOCLES_b594_3C/cluster13_cwt_old/output_cwt_cluster13_00000/inv_family_13_MCMC.hdf5' , "r") as f:
        iqk_time = list(f.keys())[0]
        G1=f.get(iqk_time+'/X')
        X_MCMC = np.array(G1)
        G1=f.get(iqk_time+'/RMS')
        RMS_MCMC = np.array(G1)
        G1=f.get(iqk_time+'/T_critic')
        T_critic = np.array(G1)
    
    data, data_spect, fc,iqk_time = mcmc_iqk.read_data.read_data(path2icqks,stations,sta_cluster,cluster,iqk,fmin,fmax,fe,plot=0)
    variance = (T_critic*1.1)**2
    idx = np.nonzero(RMS_MCMC)[0][-1]
    RMS_accepted = np.zeros(N_MCMC)
    RMS_accepted[0:idx] = RMS_MCMC[0:idx]
    
    
    if thick_var:
        MAX_param0 = np.zeros(Nsta+3)
        MIN_param0 = np.zeros(Nsta+3)    
        MAX_param0[0:Nsta] = max_thickness
        MIN_param0[0:Nsta] = min_thickness   
        MAX_param0[Nsta] = lat_max   # max latitude
        MIN_param0[Nsta] = lat_min   # min latitude
        MAX_param0[Nsta+1] = lon_max   # max longitude
        MIN_param0[Nsta+1] = lon_min   # min longitude
        MAX_param0[Nsta+2] = t[-1]        # max lag
        MIN_param0[Nsta+2] = -t[-1]      # min lag
        delta_param0 = (MAX_param0 - MIN_param0)
    
    

        X = np.zeros((3+Nsta,N_MCMC))    
        X[0:Nsta,0:idx] = X_MCMC[0:Nsta,0:idx]
        X[Nsta:Nsta+3,0:idx] = X_MCMC[Nsta:Nsta+3,0:idx]

        X, likelihood, RMS_accepted, it = mcmc_iqk.MCMC_SA.MCMC_continue_sev_thick(variance,X,stations,t,pulse,cph,hhh,data_scalogram,fe,method,delta_param0,Tminparam,MIN_param0,MAX_param0,isave,cluster,iqk,iqk_time,path2save,T_critic,data,RMS_accepted)  
    
    else:  
        MAX_param0 = np.zeros(4)
        MIN_param0 = np.zeros(4)    
        MAX_param0[0] = max_thickness
        MIN_param0[0] = min_thickness   
        MAX_param0[1] = lat_max   # max latitude
        MIN_param0[1] = lat_min   # min latitude
        MAX_param0[2] = lon_max   # max longitude
        MIN_param0[2] = lon_min   # min longitude
        MAX_param0[3] = t[-1]        # max lag
        MIN_param0[3] = -t[-1]      # min lag
        delta_param0 = (MAX_param0 - MIN_param0)
        
        X = np.zeros((4,N_MCMC))
        X[:,0:idx] = X_MCMC[:,0:idx]
        
        X, likelihood, RMS_accepted, it = mcmc_iqk.MCMC_SA.MCMC_continue(variance,X,stations,t,pulse,cph,hhh,data_scalogram,fe,method,delta_param0,Tminparam,MIN_param0,MAX_param0,isave,cluster,iqk,iqk_time,path2save,T_critic,data,RMS_accepted)  


elif not(os.path.exists(path2save+name2saveMCMC)) and os.path.exists(path2save+name2saveSA):
    import h5py 
    with h5py.File(path2save+name2saveSA , "r") as f:    
    #with h5py.File('/Users/moreaul/Documents/Travail/Projets_Recherche/Icewaveguide/data/DAMOCLES/output_scatnet_DAMOCLES_b594_3C/cluster13_cwt_old/output_cwt_cluster13_00000/inv_family_13_MCMC.hdf5' , "r") as f:
        iqk_time = list(f.keys())[0]
        G1=f.get(iqk_time+'/X')
        X = np.array(G1)
        G1=f.get(iqk_time+'/RMS')
        RMS_accepted = np.array(G1)
    f.close() 
   
    data, data_spect, fc,iqk_time = mcmc_iqk.read_data.read_data(path2icqks,stations,sta_cluster,cluster,iqk,fmin,fmax,fe,plot=0)
        
        
    MAX_param0 = np.zeros(4)
    MIN_param0 = np.zeros(4)    
    MAX_param0[0] = max_thickness
    MIN_param0[0] = min_thickness   
    MAX_param0[1] = lat_max   # max latitude
    MIN_param0[1] = lat_min   # min latitude
    MAX_param0[2] = lon_max   # max longitude
    MIN_param0[2] = lon_min   # min longitude
    MAX_param0[3] = t[-1]        # max lag
    MIN_param0[3] = -t[-1]      # min lag
    delta_param0 = (MAX_param0 - MIN_param0)



    I,T_critic, it_critic, X, likelihood, RMS_accepted = mcmc_iqk.MCMC_SA.simulated_annealing_continue(delta_param0,T0,T0param,Tmin,Tminparam,stations,X,MIN_param0,MAX_param0,t,pulse,cph,hhh,data_scalogram,fe,method,data,path2save,cluster,iqk,iqk_time,isave,RMS_accepted)
    variance = (T_critic*1.1)**2
    Xbest = X[:,I]
        
    if thick_var:
        MAX_param0 = np.zeros(Nsta+3)
        MIN_param0 = np.zeros(Nsta+3)    
        MAX_param0[0:Nsta] = max_thickness
        MIN_param0[0:Nsta] = min_thickness   
        MAX_param0[Nsta] = lat_max   # max latitude
        MIN_param0[Nsta] = lat_min   # min latitude
        MAX_param0[Nsta+1] = lon_max   # max longitude
        MIN_param0[Nsta+1] = lon_min   # min longitude
        MAX_param0[Nsta+2] = t[-1]        # max lag
        MIN_param0[Nsta+2] = -t[-1]      # min lag
        delta_param0 = (MAX_param0 - MIN_param0)
        
        X = np.zeros((3+Nsta,N_MCMC))
        X[0:Nsta,0] = Xbest[0]
        X[Nsta:Nsta+3,0] = Xbest[1:4]

        X, likelihood, RMS_accepted, it = mcmc_iqk.MCMC_SA.MCMC_sev_thick(variance,X,stations,t,pulse,cph,hhh,data_scalogram,fe,method,delta_param0,Tminparam,MIN_param0,MAX_param0,isave,cluster,iqk,iqk_time,path2save,T_critic,data)  

        
    else:
        MAX_param0 = np.zeros(4)
        MIN_param0 = np.zeros(4)    
        MAX_param0[0] = max_thickness
        MIN_param0[0] = min_thickness   
        MAX_param0[1] = lat_max   # max latitude
        MIN_param0[1] = lat_min   # min latitude
        MAX_param0[2] = lon_max   # max longitude
        MIN_param0[2] = lon_min   # min longitude
        MAX_param0[3] = t[-1]        # max lag
        MIN_param0[3] = -t[-1]      # min lag
        delta_param0 = (MAX_param0 - MIN_param0)
        
        
        X = np.zeros((4,N_MCMC))
        X[:,0] = Xbest
        
        X, likelihood, RMS_accepted, it = mcmc_iqk.MCMC_SA.MCMC(variance,X,stations,t,pulse,cph,hhh,data_scalogram,fe,method,delta_param0,Tminparam,MIN_param0,MAX_param0,isave,cluster,iqk,iqk_time,path2save,T_critic,data)  
        
        
        
    
else:
    if os.path.exists(path2save):
        shutil.rmtree(path2save)
    os.makedirs(path2save)
# initialisation for simulated annealing
    X = np.zeros((4,N_SA))
    X[0,0] = 0.5
    X[1,0] = 77.8752
    X[2,0] = 16.75
    X[3,0] = 0
        
    
    MAX_param0 = np.zeros(4)
    MIN_param0 = np.zeros(4)    
    MAX_param0[0] = max_thickness
    MIN_param0[0] = min_thickness   
    MAX_param0[1] = lat_max   # max latitude
    MIN_param0[1] = lat_min   # min latitude
    MAX_param0[2] = lon_max   # max longitude
    MIN_param0[2] = lon_min   # min longitude
    MAX_param0[3] = t[-1]        # max lag
    MIN_param0[3] = -t[-1]      # min lag
    delta_param0 = (MAX_param0 - MIN_param0)



    I,T_critic, it_critic, X, likelihood, RMS_accepted = mcmc_iqk.MCMC_SA.simulated_annealing(delta_param0,T0,T0param,Tmin,Tminparam,stations,X,MIN_param0,MAX_param0,t,pulse,cph,hhh,data_scalogram,fe,method,data,path2save,cluster,iqk,iqk_time,isave)
    
    
    variance = (T_critic*1.1)**2
    Xbest = X[:,I]
    
    if thick_var:
        MAX_param0 = np.zeros(Nsta+3)
        MIN_param0 = np.zeros(Nsta+3)    
        MAX_param0[0:Nsta] = max_thickness
        MIN_param0[0:Nsta] = min_thickness   
        MAX_param0[Nsta] = lat_max   # max latitude
        MIN_param0[Nsta] = lat_min   # min latitude
        MAX_param0[Nsta+1] = lon_max   # max longitude
        MIN_param0[Nsta+1] = lon_min   # min longitude
        MAX_param0[Nsta+2] = t[-1]        # max lag
        MIN_param0[Nsta+2] = -t[-1]      # min lag
        delta_param0 = (MAX_param0 - MIN_param0)
        
        X = np.zeros((3+Nsta,N_MCMC))
        X[0:Nsta,0] = Xbest[0]
        X[Nsta:Nsta+3,0] = Xbest[1:4]

        X, likelihood, RMS_accepted, it = mcmc_iqk.MCMC_SA.MCMC_sev_thick(variance,X,stations,t,pulse,cph,hhh,data_scalogram,fe,method,delta_param0,Tminparam,MIN_param0,MAX_param0,isave,cluster,iqk,iqk_time,path2save,T_critic,data)  

        
    else:
        MAX_param0 = np.zeros(4)
        MIN_param0 = np.zeros(4)    
        MAX_param0[0] = max_thickness
        MIN_param0[0] = min_thickness   
        MAX_param0[1] = lat_max   # max latitude
        MIN_param0[1] = lat_min   # min latitude
        MAX_param0[2] = lon_max   # max longitude
        MIN_param0[2] = lon_min   # min longitude
        MAX_param0[3] = t[-1]        # max lag
        MIN_param0[3] = -t[-1]      # min lag
        delta_param0 = (MAX_param0 - MIN_param0)
        
        
        X = np.zeros((4,N_MCMC))
        X[:,0] = Xbest
        
        X, likelihood, RMS_accepted, it = mcmc_iqk.MCMC_SA.MCMC(variance,X,stations,t,pulse,cph,hhh,data_scalogram,fe,method,delta_param0,Tminparam,MIN_param0,MAX_param0,isave,cluster,iqk,iqk_time,path2save,T_critic,data)  
        






















