#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Thu May 13 10:21:23 2021

@author: moreaul
"""

import mcmc_iqk
import numpy as np
from random import random

def simulated_annealing(delta_param0,T0,T0param,Tmin,Tminparam,stations,X,MIN_param0,MAX_param0,t,pulse,cph,hhh,data_scalogram,fe,method,data,path2save,cluster,iqk,iqk_time,isave):
    N_SA = X.shape[1]
    
    T = np.exp(np.linspace(np.log(T0),np.log(Tmin),N_SA));variance = T**2
    Tparam = np.exp(np.linspace(np.log(T0param),np.log(Tminparam),N_SA));
    T_critic = Tmin
    it_critic = N_SA
    
    RMS_accepted = np.zeros(N_SA)
    likelihood = np.zeros(N_SA)
    
    
    synthetics = mcmc_iqk.synthetics.synthetics(stations,X[:,0],t,pulse,cph[np.abs(hhh - X[0,0]).argmin()],plot=0)
    RMS_accepted[0],_ = mcmc_iqk.cost_function.cost_function(data_scalogram,data,synthetics,fe,method)
    likelihood[0] = np.exp( -RMS_accepted[0]**2 / (2*variance[0] ))
    
    
    
    
    it = 1
    it_tot = 0
    cpt_out = 0
    while it <= N_SA-1: 
        it_tot = it_tot+1
        delta_param = delta_param0*Tparam[it]
        Xtest = mcmc_iqk.candidate.candidate(X[:,it-1],delta_param,MIN_param0,MAX_param0);     
        synthetics = mcmc_iqk.synthetics.synthetics(stations,Xtest,t,pulse,cph[np.abs(hhh - Xtest[0]).argmin()],plot=0)    
        RMS_cand,_  = mcmc_iqk.cost_function.cost_function( data_scalogram,data,synthetics,fe,method )
    
        likelihood_cand = np.exp( -RMS_cand**2 / (2*variance[it]) )
    
        test_likelihood = min(1,likelihood_cand/likelihood[it-1])
    
        if  random() < test_likelihood:
            X[:,it] = Xtest
            RMS_accepted[it] = RMS_cand
            likelihood[it] = likelihood_cand
            cpt_out = 0
            it = it + 1
            print(it)
        else:
        #X[:,it] = X[:,it-1];
        #RMS_accepted[it] = RMS_accepted[it-1]
        #likelihood[it] = likelihood[it-1]
            cpt_out = cpt_out + 1; 
        #print(it)
        #print(str(cpt_out)+ ' itations without accepted candidate')
            if cpt_out > 200:
                I = np.argmin(RMS_accepted[0:it])
                T_critic = T[it]
                it_critic = it
                mcmc_iqk.save_inversion.save_inversion(cluster,iqk,iqk_time,path2save,X,RMS_accepted,T_critic,MCMC=0)
                mcmc_iqk.plot_mcmc.plot_mcmc(it,data,data_scalogram,t,pulse,cph,fe,hhh,RMS_accepted,X,stations,method,path2save,savefig=1)
                break
          
        


        if it % isave == 0 and cpt_out<1:
            mcmc_iqk.save_inversion.save_inversion(cluster,iqk,iqk_time,path2save,X,RMS_accepted,T_critic,MCMC=0)
            mcmc_iqk.plot_mcmc.plot_mcmc(it,data,data_scalogram,t,pulse,cph,fe,hhh,RMS_accepted,X,stations,method,path2save,savefig=1)
            
    I = np.argmin(RMS_accepted[0:it_critic])        
            
    return I,T_critic, it_critic, X, likelihood  ,RMS_accepted          
            
 
def simulated_annealing_continue(delta_param0,T0,T0param,Tmin,Tminparam,stations,X,MIN_param0,MAX_param0,t,pulse,cph,hhh,data_scalogram,fe,method,data,path2save,cluster,iqk,iqk_time,isave,RMS_accepted):
    N_SA = X.shape[1]
    
    #name2saveSA = 'inv_family_' + f'{cluster:02d}' +'_SA.hdf5' 
    #import h5py 
    #with h5py.File(path2save+name2saveSA , "r") as f:    
    #with h5py.File('/Users/moreaul/Documents/Travail/Projets_Recherche/Icewaveguide/data/DAMOCLES/output_scatnet_DAMOCLES_b594_3C/cluster13_cwt_old/output_cwt_cluster13_00000/inv_family_13_MCMC.hdf5' , "r") as f:
    #    iqk_time = list(f.keys())[0]
    #    G1=f.get(iqk_time+'/RMS')
    #    RMS_accepted = np.array(G1)
    #f.close()
    it = np.nonzero(RMS_accepted)[0][-1]
    
    
    
    T = np.exp(np.linspace(np.log(T0),np.log(Tmin),N_SA));variance = T**2
    Tparam = np.exp(np.linspace(np.log(T0param),np.log(Tminparam),N_SA));
    T_critic = Tmin
    it_critic = N_SA
    
    likelihood = np.zeros(N_SA)
    likelihood[0:it] = np.exp( -RMS_accepted[0:it]**2 / (2*variance[0:it] ))
    
    it_tot = 0
    cpt_out = 0
    while it <= N_SA-1: 
        it_tot = it_tot+1
        delta_param = delta_param0*Tparam[it]
        Xtest = mcmc_iqk.candidate.candidate(X[:,it-1],delta_param,MIN_param0,MAX_param0);     
        synthetics = mcmc_iqk.synthetics.synthetics(stations,Xtest,t,pulse,cph[np.abs(hhh - Xtest[0]).argmin()],plot=0)    
        RMS_cand,_  = mcmc_iqk.cost_function.cost_function( data_scalogram,data,synthetics,fe,method )
    
        likelihood_cand = np.exp( -RMS_cand**2 / (2*variance[it]) )
    
        test_likelihood = min(1,likelihood_cand/likelihood[it-1])
    
        if  random() < test_likelihood:
            X[:,it] = Xtest
            RMS_accepted[it] = RMS_cand
            likelihood[it] = likelihood_cand
            cpt_out = 0
            it = it + 1
            print(it)
        else:
        #X[:,it] = X[:,it-1];
        #RMS_accepted[it] = RMS_accepted[it-1]
        #likelihood[it] = likelihood[it-1]
            cpt_out = cpt_out + 1; 
        #print(it)
        #print(str(cpt_out)+ ' itations without accepted candidate')
            if cpt_out > 200:
                I = np.argmin(RMS_accepted[0:it])
                T_critic = T[it]
                it_critic = it
                mcmc_iqk.save_inversion.save_inversion(cluster,iqk,iqk_time,path2save,X,RMS_accepted,T_critic,MCMC=0)
                mcmc_iqk.plot_mcmc.plot_mcmc(it,data,data_scalogram,t,pulse,cph,fe,hhh,RMS_accepted,X,stations,method,path2save,savefig=1)
                break
          
        


        if it % isave == 0 and cpt_out<1:
            mcmc_iqk.save_inversion.save_inversion(cluster,iqk,iqk_time,path2save,X,RMS_accepted,T_critic,MCMC=0)
            mcmc_iqk.plot_mcmc.plot_mcmc(it,data,data_scalogram,t,pulse,cph,fe,hhh,RMS_accepted,X,stations,method,path2save,savefig=1)
            
    I = np.argmin(RMS_accepted[0:it_critic])        
            
    return I,T_critic, it_critic, X, likelihood  ,RMS_accepted       




def MCMC_sev_thick(variance,X,stations,t,pulse,cph,hhh,data_scalogram,fe,method,delta_param0,Tminparam,MIN_param0,MAX_param0,isave,cluster,iqk,iqk_time,path2save,T_critic,data):
    N_MCMC = X.shape[1]
    Nsta = stations.shape[0]
    it = 1
    it_tot = 0
    cpt_out = 0


    RMS_accepted = np.zeros(N_MCMC)
    likelihood = np.zeros(N_MCMC)   
    cph_tmp = np.zeros((Nsta,cph.shape[1]))
    for ista in range(Nsta):
        cph_tmp[ista,:] = cph[np.abs(hhh - X[ista,0]).argmin()]
     
    synthetics = mcmc_iqk.synthetics.synthetics_var_thick(stations,X[Nsta-1:,0],t,pulse,cph_tmp,plot=0) 
    RMS_accepted[0],_  = mcmc_iqk.cost_function.cost_function( data_scalogram,data,synthetics,fe,method)     
    likelihood[0] = np.exp( -RMS_accepted[0]**2 / (2*variance) )
    


    while it < N_MCMC-1: 
        it_tot = it_tot+1
        
        delta_param = delta_param0*Tminparam
        Xtest = mcmc_iqk.candidate.candidate(X[:,it-1],delta_param,MIN_param0,MAX_param0);   
        
        cph_tmp = np.zeros((Nsta,cph.shape[1]))
        for ista in range(Nsta):
            cph_tmp[ista,:] = cph[np.abs(hhh - Xtest[ista]).argmin()]
     
        
        synthetics = mcmc_iqk.synthetics.synthetics_var_thick(stations,Xtest[Nsta-1:],t,pulse,cph_tmp,plot=0)     
        RMS_cand,_  = mcmc_iqk.cost_function.cost_function( data_scalogram,data,synthetics,fe,method )
    
        
        likelihood_cand = np.exp( -RMS_cand**2 / (2*variance) )
    
        test_likelihood = min(1,likelihood_cand/likelihood[it-1])
    
        if  random() < test_likelihood:
            X[:,it] = Xtest
            RMS_accepted[it] = RMS_cand
            likelihood[it] = likelihood_cand
            cpt_out = 0
            it = it + 1
            print(it)
        else:
            cpt_out = cpt_out + 1;             
            if cpt_out > 200:
                print('cpt_out = ' + str(cpt_out))
                T_critic = T_critic*1.1
                variance = (T_critic*1.1)**2
                cpt_out = 0

        if it % isave == 0 and cpt_out<1:
            mcmc_iqk.save_inversion.save_inversion(cluster,iqk,iqk_time,path2save,X,RMS_accepted,T_critic,MCMC=1)
            mcmc_iqk.plot_mcmc.plot_mcmc(it,data,data_scalogram,t,pulse,cph,fe,hhh,RMS_accepted,X,stations,method,path2save,savefig=1)



    return X, likelihood, RMS_accepted, it 




def MCMC_continue_sev_thick(variance,X,stations,t,pulse,cph,hhh,data_scalogram,fe,method,delta_param0,Tminparam,MIN_param0,MAX_param0,isave,cluster,iqk,iqk_time,path2save,T_critic,data,RMS_accepted):
    N_MCMC = X.shape[1]
    
    
    it = np.nonzero(RMS_accepted)[0][-1]
    it_tot = 0
    cpt_out = 0
    likelihood = np.zeros(N_MCMC)   
      
    likelihood[0:it] = np.exp( -RMS_accepted[0:it]**2 / (2*variance) )
    


    while it < N_MCMC-1: 
        it_tot = it_tot+1
        
        delta_param = delta_param0*Tminparam
        Xtest = mcmc_iqk.candidate.candidate(X[:,it-1],delta_param,MIN_param0,MAX_param0);     
        synthetics = mcmc_iqk.synthetics.synthetics(stations,Xtest,t,pulse,cph[np.abs(hhh - Xtest[0]).argmin()],plot=0)   
        RMS_cand,_  = mcmc_iqk.cost_function.cost_function( data_scalogram,data,synthetics,fe,method)
        

        likelihood_cand = np.exp( -RMS_cand**2 / (2*variance) )
        #print(likelihood[it-1])
        #print(likelihood_cand)
    
        test_likelihood = min(1,likelihood_cand/likelihood[it-1])
    
        if  random() < test_likelihood:
            X[:,it] = Xtest
            RMS_accepted[it] = RMS_cand
            likelihood[it] = likelihood_cand
            cpt_out = 0
            it = it + 1
            print(it)

        else:
            cpt_out = cpt_out + 1;
            
            #print(it)
            #print('cpt_out = ' + str(cpt_out))   
            #print(Xtest)
            if cpt_out > 200:
                T_critic = T_critic*1.1
                variance = (T_critic*1.1)**2
                cpt_out = 0

        if it % isave == 0 and cpt_out<1:
            mcmc_iqk.save_inversion.save_inversion(cluster,iqk,iqk_time,path2save,X,RMS_accepted,T_critic,MCMC=1)
            mcmc_iqk.plot_mcmc.plot_mcmc(it,data,data_scalogram,t,pulse,cph,fe,hhh,RMS_accepted,X,stations,method,path2save,savefig=1)



    return X, likelihood, RMS_accepted, it 





def MCMC(variance,X,stations,t,pulse,cph,hhh,data_scalogram,fe,method,delta_param0,Tminparam,MIN_param0,MAX_param0,isave,cluster,iqk,iqk_time,path2save,T_critic,data):
    N_MCMC = X.shape[1]
    it = 1
    it_tot = 0
    cpt_out = 0


    RMS_accepted = np.zeros(N_MCMC)
    likelihood = np.zeros(N_MCMC)   
   
     
    synthetics = mcmc_iqk.synthetics.synthetics(stations,X[:,0],t,pulse,cph[np.abs(hhh - X[0,0]).argmin()],plot=0) 
    RMS_accepted[0],_  = mcmc_iqk.cost_function.cost_function( data_scalogram,data,synthetics,fe,method)     
    likelihood[0] = np.exp( -RMS_accepted[0]**2 / (2*variance) )
    


    while it < N_MCMC-1: 
        it_tot = it_tot+1
        
        delta_param = delta_param0*Tminparam
        Xtest = mcmc_iqk.candidate.candidate(X[:,it-1],delta_param,MIN_param0,MAX_param0);   
        synthetics = mcmc_iqk.synthetics.synthetics(stations,Xtest,t,pulse,cph[np.abs(hhh - Xtest[0]).argmin()],plot=0)    
        RMS_cand,_  = mcmc_iqk.cost_function.cost_function( data_scalogram,data,synthetics,fe,method)
    
        
        likelihood_cand = np.exp( -RMS_cand**2 / (2*variance) )
    
        test_likelihood = min(1,likelihood_cand/likelihood[it-1])
    
        if  random() < test_likelihood:
            X[:,it] = Xtest
            RMS_accepted[it] = RMS_cand
            likelihood[it] = likelihood_cand
            cpt_out = 0
            it = it + 1
            print(it)
        else:
            cpt_out = cpt_out + 1;             
            if cpt_out > 200:
                print('cpt_out = ' + str(cpt_out))
                T_critic = T_critic*1.1
                variance = (T_critic*1.1)**2
                cpt_out = 0

        if it % isave == 0 and cpt_out<1:
            mcmc_iqk.save_inversion.save_inversion(cluster,iqk,iqk_time,path2save,X,RMS_accepted,T_critic,MCMC=1)
            mcmc_iqk.plot_mcmc.plot_mcmc(it,data,data_scalogram,t,pulse,cph,fe,hhh,RMS_accepted,X,stations,method,path2save,savefig=1)



    return X, likelihood, RMS_accepted, it 


  


def MCMC_continue(variance,X,stations,t,pulse,cph,hhh,data_scalogram,fe,method,delta_param0,Tminparam,MIN_param0,MAX_param0,isave,cluster,iqk,iqk_time,path2save,T_critic,data,RMS_accepted):
    N_MCMC = X.shape[1]
        
    
    it = np.nonzero(RMS_accepted)[0][-1]
    it_tot = 0
    cpt_out = 0
    likelihood = np.zeros(N_MCMC)   
      
    likelihood[0:it] = np.exp( -RMS_accepted[0:it]**2 / (2*variance) )
    


    while it < N_MCMC-1: 
        it_tot = it_tot+1
        
        delta_param = delta_param0*Tminparam
        Xtest = mcmc_iqk.candidate.candidate(X[:,it-1],delta_param,MIN_param0,MAX_param0);     
        synthetics = mcmc_iqk.synthetics.synthetics(stations,Xtest,t,pulse,cph[np.abs(hhh - Xtest[0]).argmin()],plot=0)   
        RMS_cand,_  = mcmc_iqk.cost_function.cost_function(data_scalogram,data,synthetics,fe,method)
        

        likelihood_cand = np.exp( -RMS_cand**2 / (2*variance) )
        #print(likelihood[it-1])
        #print(likelihood_cand)
    
        test_likelihood = min(1,likelihood_cand/likelihood[it-1])
    
        if  random() < test_likelihood:
            X[:,it] = Xtest
            RMS_accepted[it] = RMS_cand
            likelihood[it] = likelihood_cand
            cpt_out = 0
            it = it + 1
            print(it)

        else:
            cpt_out = cpt_out + 1;
            
            #print(it)
            #print('cpt_out = ' + str(cpt_out))   
            #print(Xtest)
            if cpt_out > 200:
                T_critic = T_critic*1.1
                variance = (T_critic*1.1)**2
                cpt_out = 0

        if it % isave == 0 and cpt_out<1:
            mcmc_iqk.save_inversion.save_inversion(cluster,iqk,iqk_time,path2save,X,RMS_accepted,T_critic,MCMC=1)
            mcmc_iqk.plot_mcmc.plot_mcmc(it,data,data_scalogram,t,pulse,cph,fe,hhh,RMS_accepted,X,stations,method,path2save,savefig=1)



    return X, likelihood, RMS_accepted, it 


















         