#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Mar 15 21:20:41 2021

@author: moreaul
"""

import mcmc_iqk
import numpy as np
import math

def mean2(x):
    y = np.sum(x) / np.size(x);
    return y

def corr2(a,b):
    a = a - mean2(a)
    b = b - mean2(b)

    r = (a*b).sum() / math.sqrt((a*a).sum() * (b*b).sum());
    return r

def least_squares(a,b):
    dim = a.shape[0]*b.shape[1]
    r = np.sum((a/np.max(a)-b/np.max(b))**2)/dim
    return r

def cost_function( data_scalogram,data,synthetics,fe,method):
    


    if method == 'xcorr':
        corr_sign = np.zeros(len(data))
        corr = 0
        for ista in range(len(data)):  
            tmp = np.corrcoef(data[ista],synthetics[ista,:])[1][0]
            corr = corr + (1-np.abs(tmp))
            corr_sign[ista] = np.sign(tmp)
    
        cost = corr/len(data)
        

    else:
        synthetics_scalogram = mcmc_iqk.data_cwt.data_cwt(synthetics,fe,method,plot=0)
    
    
    
    
        tmp = 0
        corr_sign = np.zeros(synthetics.shape[0])
        for ista in range(synthetics.shape[0]):
            corr_sign[ista] = corr2(synthetics_scalogram[ista], data_scalogram[ista])
            
            #use corr2 function to calculate cost fdunction from correlation coefficient:
            #tmp = tmp + 1 - abs(corr_sign[ista])
            
            #use least_squares function to calculate cost fdunction from least squares:
            tmp = tmp + least_squares(synthetics_scalogram[ista], data_scalogram[ista])
            
        
        cost = tmp/synthetics.shape[0]
        corr_sign = np.sign(corr_sign)
        
    return cost, corr_sign

