#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Mar 16 10:36:41 2021

@author: moreaul
"""

import numpy as np
import matplotlib.pyplot as plt

import scipy

#import pywt

def data_cwt(data,fe,method,plot):
    data_scalogram = []
    
    if method == 'cwt':
        import pywt
        wavelet = 'cmor1.5-1.0'
        scales = np.arange(5,256,2)    
        t = np.arange(0,(np.shape(data)[1])/fe,1/fe)
        for ista in range(np.shape(data)[0]): 
            [cfs, frequencies] = pywt.cwt(data[ista], scales, wavelet, 1/fe)
            data_scalogram.append((abs(cfs)) ** 2)
    
     
    elif method == 'stft':
        for ista in range(np.shape(data)[0]): 
            frequencies, t, cfs = scipy.signal.stft(data[ista], fs=fe, window='hann', nperseg=fe/2, noverlap=fe/5, nfft=512)
            data_scalogram.append(abs(cfs))
    
    
        
    
    
    if plot:
        fig, axs = plt.subplots(1,5, figsize=(15, 5), facecolor='w', edgecolor='k')
        fig.subplots_adjust(hspace = .5, wspace=.5)
        axs = axs.ravel() 
        for ista in range(np.shape(data)[0]):
            tmp = np.abs(data_scalogram[ista]/np.amax(abs(data_scalogram[ista])))
            axs[ista].pcolormesh(t,frequencies,20*np.log10(tmp/np.amax(tmp)), vmin=-80, vmax =0, shading='gouraud')
            axs[ista].set_ylim(0, 50)
            axs[ista].set_title('scalogram for station ' + str(ista))
            axs[ista].set(xlabel='time in icequake (s)', ylabel='spectrum amplitude in dB of max')
            #axs[ista].xlabel('time in icequake (s)')
            #axs[ista].ylabel('cwt in dB of max')
        plt.show()
        
    return data_scalogram