#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Mar 15 16:44:11 2021

@author: moreaul
"""

import numpy as np

def gaussian_toneburst(fc,t,t0,T,k,x,SNR):
    omeg = 2*np.pi*fc
    sigma = T/4.71
    envel = np.exp(-(t-t0)**2/(2*sigma**2))
    pulse = np.sin(omeg*t-k*x) * envel
    
    norm_noise = 2*np.random.rand(1,len(t))-1
    P_noise = 1/(t[-1]-t[0])*np.trapz(norm_noise**2, x=None, dx=t[1]-t[0], axis=-1)
    P_s = 1/(t[-1]-t[0])*np.trapz(pulse**2, x=None, dx=t[1]-t[0], axis=-1)
    if SNR==np.inf:
        noise = 0
    else:
        A_noise = np.sqrt(P_s/P_noise/10**(SNR/10))
        noise = A_noise*norm_noise[0]
    
    signal = pulse+noise
    return signal