#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Thu Mar 18 14:12:49 2021

@author: moreaul
"""

import h5py
import os


def save_inversion(cluster,iqk,iqk_time,path2save,X,RMS_accepted,T_critic,MCMC):

    name2saveSA = 'inv_family_' + f'{cluster:02d}' +'_SA.hdf5' 
    name2saveMCMC = 'inv_family_' + f'{cluster:02d}' +'_MCMC.hdf5' 
    groupname = 'iqk_' + f'{iqk:05d}' + ':' + iqk_time
    print(groupname)

    if not MCMC:
         if not os.path.exists(path2save+name2saveSA):
             f = h5py.File(path2save+name2saveSA,'w')
             dset = f.create_dataset(groupname+ '/X', data = X, dtype='float32') 
             dset = f.create_dataset(groupname+ '/RMS', data = RMS_accepted, dtype='float32') 
             dset = f.create_dataset(groupname+ '/T_critic', data = T_critic, dtype='float32')
         else:
            f = h5py.File(path2save+name2saveSA,'r+')
            tmp = f[groupname +'/X']
            tmp[...] = X
            del tmp
            tmp = f[groupname +'/RMS']
            tmp[...] = RMS_accepted
            del tmp
            tmp = f[groupname +'/T_critic']
            tmp[...] = T_critic
            del tmp  
    elif MCMC:
        if not os.path.exists(path2save+name2saveMCMC):
             f = h5py.File(path2save+name2saveMCMC,'w')
             dset = f.create_dataset(groupname+ '/X', data = X, dtype='float32') 
             dset = f.create_dataset(groupname+ '/RMS', data = RMS_accepted, dtype='float32') 
             dset = f.create_dataset(groupname+ '/T_critic', data = T_critic, dtype='float32')
        else:
            f = h5py.File(path2save+name2saveMCMC,'r+')
            tmp = f[groupname +'/X']
            tmp[...] = X
            del tmp
            tmp = f[groupname +'/RMS']
            tmp[...] = RMS_accepted
            del tmp
            tmp = f[groupname +'/T_critic']
            tmp[...] = T_critic
            del tmp 
    

    f.close()  

    
        
        
        