#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Mar 16 21:26:57 2021

@author: moreaul
"""

import numpy as np
from geopy.distance import distance
import mcmc_iqk

def synthetics(stations,X,t,pulse,cph,plot):

    
    fe = 1/(t[1]-t[0])
    distances = np.zeros(stations.shape[0])
    synthetics = np.zeros((stations.shape[0],len(t)))
    
    for ista in range(stations.shape[0]):
        distances[ista] = distance((stations[ista,1], stations[ista,2]), (X[1], X[2])).m 
        tmp = mcmc_iqk.fwd_model.propag_dispersive_wave_1D(t,pulse[ista],distances[ista],   np.concatenate(   [cph[::-1], cph[1:]]  )    )
        synthetics[ista] = np.roll((tmp[0])/np.amax(tmp[0]),int(np.floor(X[3]*fe)))
    
    
    if plot:
        import matplotlib.pyplot as plt
        fig2, ax2 = plt.subplots(1,1, figsize=(15, 5), facecolor='w', edgecolor='k')
        for ista in range(stations.shape[0]):    
            plt.plot(t,synthetics[ista]+ista)
            plt.xlabel('time in synthetics (s)')
            plt.ylabel('synthetics amplitude (normalized max)')
            plt.title('synthetics waveforms')
        plt.show()
        
    return synthetics